//
// Copyright (C) 1999-2004 Toshikaz Hirabayashi
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// TOSHIKAZ HIRABAYASHI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// Except as contained in this notice, the name of Toshikaz Hirabayashi shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from
// Toshikaz Hirabayashi.

#ifndef WSCLISTDATA_H
#define WSCLISTDATA_H

#include <WScom.h>

class WSClistData{

    void**  _data;
    unsigned _num:24;
    unsigned char _seg_size;
//    void _set_num(long);

  public:
    WSClistData();
    WSClistData(long);
    WSClistData(WSClistData&);
    WSClistData(const WSClistData&);
    virtual ~WSClistData();

    long   add(void* data,long i =-1);
//    long   add(WSClistData* list);
    void   setData(long i,void*);

    void*  getData(long i);
    long   getNum();
    void*  getTopData();
    void*  getBottomData();
    void** getBuf();

    long   del(void* data);
    long   delPos(long i);      
    void   clear();
    WSClistData& operator = (WSClistData&);
    void*  &operator[](long index);
//    const void*  &operator[](long index) const;
};
#endif
